В этом файле описано использование и устройство PINENTRY.

   Это редакция 1.0.1-beta21 (17 июня 2017) ‘Руководства по pinentry’
для версии 1.0.1-beta21.

   Опубликовано g10 Code GmbH
Hüttenstr.  61
40699 Erkrath, Германия

   Copyright © 2002, 2005, 2015 g10 Code GmbH

   Copyright © 2016 Ineiev <ineiev@gnu.org> (translation)

   Разрешается копировать, распространять и модифицировать этот документ
на условиях Стандартной общественной лицензии GNU в том виде, в каком
она опубликована Фондом свободного программного обеспечения; либо версии
3 этой лицензии, либо (по вашему выбору) любой более поздней версии.
Текст лицензии находится в разделе, озаглавленном «Copying».

Введение
********

В этом руководстве описано пользование программой PINENTRY и ее
протокол.

   Программа PINENTRY представляет небольшое интерактивное приложение
для ввода PIN или фраз-паролей.  Обычно оно вызывается программой
GPG-AGENT (see Вызов gpg-agent (gnupg)).

   Есть несколько вариантов PINENTRY, которые отличаются внешним видом в
зависимости от библиотеки пользовательского интерфейса: ‘pinentry-gtk’
(на базе GTK+), ‘pinentry-qt’ (на базе QT), а также два текстовых,
‘pinentry-curses’ (на базе curses) и ‘pinentry-tty’, который не требует
ничего, кроме простого терминала.  Некоторые из них у вас могут быть не
установлены.  Если в вашей системе поддерживается библиотека curses,
графические варианты используют ее как запасной вариант, когда
переменная ‘DISPLAY’ не установлена.

Сведения для разработчиков

Прочее

Указатели

1 Как пользоваться PINENTRY
***************************

Программу PINENTRY можно запустить прямо из командной строки и выполнять
команды по протоколу Assuan через стандартные потоки ввода и вывода.

   Вот список параметров, которые поддерживают все варианты PINENTRY:

‘--version’
     Вывести версию программы и лицензионные сведения.

‘--help’
     Вывести подсказку по наиболее полезным параметрам командной строки.

‘--debug’
‘-d’
     Включить некоторый отладочный вывод.  Полезно в основном для
     разработчиков.  Обратите внимание, что это может раскрывать такие
     важные данные, как фраза-пароль.

‘--no-global-grab’
‘-g’
     Перехватывать клавиатуру, только когда окно активно.  Этот параметр
     предназначен для отладки программ, пользующихся PINENTRY; без него
     у вас не будет доступа к сеансу X (если у вас нет других средств
     подключиться к машине, чтобы снять PINENTRY с выполнения).

‘--parent-wid N’
     Пользоваться окном с данным идентификатором как порождающим окном
     для размещения окна.  Обратите внимание, что это полностью
     поддерживается не во всех вариантах PINENTRY.

‘--timeout СЕКУНДЫ’
     Прекратить ожидание ввода от пользователя после указанного числа
     секунд, возвратив ошибку.  Возвращается та же ошибка, как при
     нажатии кнопки отмены.  Чтобы программа ожидала ввода неопределенно
     долго, задайте в качестве аргумента 0 (что является исходным
     значением).

‘--display СТРОКА’
‘--ttyname СТРОКА’
‘--ttytype СТРОКА’
‘--lc-ctype СТРОКА’
‘--lc-messages СТРОКА’
     Эти параметры предназначены для передачи в PINENTRY сведений о
     локализации.  Они необходимы, поскольку PINENTRY обычно вызывается
     каким-то фоновым процессом, в котором нет никакой информации о
     языке и терминале, которые будут использоваться.  Эти параметры
     можно передать также с помощью параметров протокола Assuan.

2 Пользовательские оболочки
***************************

Есть несколько разных вариантов PINENTRY, а именно, варианты Gtk+2,
Qt 4, Gnome 3, Emacs, curses и tty.  Эти различные реализации
обеспечивают интеграцию с конкретной средой на более высоком уровне.
Например, вариант Gnome 3 отображает запросы с помощью элементов
Gnome 3.  Для пользователей Gnome 3 этот повышенный уровень интеграции
обеспечивает эстетически цельную среду.  Однако есть и недостатки.
Такое большое количество компонентов в PINENTRY снижает надежность.  В
частности, больше возможностей того, что фраза-пароль будет сохранена в
памяти, которая станет доступна для злоумышенника (ср.  уязвимость
Heartbeet в OpenSSL).

   Чтобы понять, сколько компонентов работает с фразой-паролем,
рассмотрим ту же реализацию Gnome 3.  Когда пользователь нажимает на
клавишу, ее код передается из ядра через сервер XWindow в библиотеку
(Gtk+) и в само поле ввода текста.  По пути код клавиши обрабатывается и
сохраняется в памяти.  В действительности нажатия на клавиши, вероятно,
считываются с помощью функций стандартной библиотеки Си, которая
буферирует вводимые символы.  Никакие из этих процедур не заботятся о
том, чтобы не произошло утечки содержимого памяти; они не сохраняют
данные в защищенной от записи на диск памяти и не обнуляют память перед
освобождением.  Однако даже если бы они это делали, остается проблема с
переходом компьютера в спящий режим, когда система все равно записывает
защищенные страницы памяти на диск.  Далее, многие системы работают в
виртуальной среде (например, под Xen) и практически не контролируют свои
ресурсы.

   Вариант curses пользуется гораздо меньшим наслоением программ, а
вариант tty — еще меньшим.  Однако если они работают в терминале
XWindow, то фразу-пароль обрабатывают примерно столько же компонент, как
в случае Gnome 3!  Таким образом, для наибольшей безопасности вам нужно
направить GPG Agent на пользование фиксированной виртуальной консолью.
Поскольку для того, чтобы GPG Agent пользовался этой консолью, вам нужно
оставаться в системе, вам нужно работать там, причем ‘screen’ или ‘tmux’
должны захватывать tty.

   Реализация pinentry на базе Emacs взаимодействует с работающим
экземпляром Emacs и дает ему указание отобразить запрос фразы-пароля.
Поскольку это не очень-то работает, когда никакой экземпляр Emacs не
выполняется, обобщенная механика PINENTRY проверяет, должен ли
вызываться Emacs с поддержкой PINENTRY.  А именно, проверяется,
установлена ли переменная ‘INSIDE_EMACS’, а затем предпринимается
попытка установить связь по указанному адресу.  В этом случае вместо,
напр., запуска ‘pinentry-gtk2’, вводящего пароль через Gtk+2, программа
взаимодействует с сеансом Emacs.  Эту функцию можно явным образом
выключить с помощью параметра ‘--disable-inside-emacs’ при запуске
‘configure’ перед сборкой PINENTRY.

   Вводить фразы-пароли с помощью Emacs удобно, однако это сопряжено со
значительным риском.  Emacs сохраняет в буфере все нажатия на клавиши.
(Последние нажатия можно увидеть с помощь комбинации ‘C-h l’
(‘view-lossage’).)  Однако Emacs — огромная программа, она не
обеспечивает серьезной изоляции процесса.  Таким образом обработка
фраз-паролей в Emacs добавляет огромный массив программ, которым
пользователю приходится доверять.  По этой причине в Emacs это по
умолчанию выключено (пользователю нужно явным образом выполнить
‘(pinentry-start)’, напр., в своем файле ‘.emacs’).

   Подобно проверке, связанной с Emacs, пользовательские оболочки
PINENTRY проверяют, установлена ли переменная ‘DISPLAY’ и есть ли
работающий сервер X. Если это не так, они вызывают как запасной вариант
оболочку на базе curses.  Это тоже можно отключить во время сборки
параметром ‘--disable-fallback-curses’ при запуске ‘configure’.

3 Протокол Assuan PINENTRY
**************************

Программа PINENTRY никогда не должна обслуживать более одного соединения
одновременно.  Разумно выполнять exec PINENTRY перед запросом.

   Программе PINENTRY не обязательно оставаться в памяти, потому что
GPG-AGENT способен запоминать фразы-пароли.  Обычно c PINENTRY работают,
организовывая канал (не сокет) с последующим выполнением fork/exec
PINENTRY.  Затем средствами описанного здесь протокола осуществляется
связь, пока клиент не получает удовлетворительный результат.

   Хотя программа называется PINENTRY, она позволяет вводить достаточно
длинные строки (все варианты поддерживают строки длиной до 2048
символов).  Программа-клиент, пользующаяся PINENTRY, должна проверять
корректность.

   Обратите внимание, что все строки ожидаются в кодировке UTF-8;
PINENTRY преобразует их в местную кодировку.  Чтобы вводить символы
перевода строки и другие специальные символы, вы можете экранировать их
процентом (напр., перевод строки кодируется как ‘%0A’, сам знак процента
кодируется как ‘%25’ и т.д.

   Далее приводится список поддерживаемых команд.

‘Задать время ожидания перед возвратом ошибки’
            C: SETTIMEOUT 30
            S: OK

‘Задать пояснительный текст для отображения’
            C: SETDESC Введите PIN Леонида Брежнева <nobody@ussr.gov>
            S: OK

‘Задать текст запроса’
     При запросе PIN задать текст, который выводится непосредственно
     перед полем ввода фразы-пароля.
            C: SETPROMPT PIN:
            S: OK

     Символом подчеркивания можно пользоваться только с современными
     версиями PINENTRY.  В современных версиях следующий после
     подчеркивания символ подчеркивается, а первый из таких символов
     используется в качестве клавиши быстрого доступа.  Сам символ
     подчеркивания можно ввести, удваивая символ.

‘Задать заголовок окна’
     Этой командой можно изменить исходный заголовок окна.  При этом
     нужно позаботиться о том, чтобы можно было понять, что окно
     относится к PINENTRY.
            C: SETTITLE Камера звукозаписи
            S: OK

‘Задать тексты кнопок’
     Есть три текста, с помощью которых следует изменять исходные
     английские значения:

     Установить текст кнопки, сигнализирующей подтверждение (в UTF-8).
     Клавиша быстрого доступа устанавливается, как в SETPROMPT.
            C: SETOK Так точно
            S: OK

     Установить текст кнопки, сигнализирующей отмену или несогласие (в
     UTF-8).  Клавиша быстрого доступа устанавливается, как в SETPROMPT.
            C: SETCANCEL Отставить
            S: OK

     Когда требуется три кнопки, следующая команда устанавливает текст
     (в UTF-8) для неподтверждающей кнопки.  Текст для подтверждающей
     кнопки по-прежнему устанавливается с помощью SETOK, а текст кнопки
     отмены устанавливается с помощью SETCANCEL. Клавиша быстрого
     доступа устанавливается, как в SETPROMPT.
            C: SETNOTOK Никак нет
            S: OK

‘Задать текст ошибки’
     С помощью этой команда программа-клиент отображает сообщение об
     ошибке.  В отличие от других команд, сообщение об ошибке
     автоматически сбрасывается командами GETPIN и CONFIRM и
     показывается только при запросе PIN.
            C: SETERROR Введен неверный PIN - попробуйте еще раз
            S: OK

‘Включить индикатор качества фразы-пароля’
     Добавить в окно GETPIN индикатор качества.  Этот индикатор
     обновляется в процессе ввода фразы-пароля.  Программы-клиенты
     должны реализовать ответ на запрос «QUALITY», в котором они
     получают текущую фразу-пароль (экранированную процентом и плюсом) и
     должны высылать в ответ одно численное значение в диапазоне от -100
     до 100.  Отрицательные значения будут отображаться красным цветом.
            C: SETQUALITYBAR
            S: OK

     Если для индикатора качества нужна особая метка, добавьте ее текст
     в качестве аргумента в виде строки, экранированной процентом.  Это
     понадобится для перевода метки, потому что в PINENTRY gettext не
     используется, кроме строк из библиотеки пользовательского
     интерфейса.

     Если вы хотите показать для индикатора качества всплывающую
     подсказку, можно воспользоваться командой
            C: SETQUALITYBAR_TT строка
            S: OK

     Где аргумент — экранированная процентом строка, которая выводится в
     качестве всплывающей подсказки.

‘Запрос PIN’
     Главное в этой программе — запрос фразы-пароля или PIN, это
     делается командой:
            C: GETPIN
            S: D баста, карапузики
            S: OK
     Обратите внимание, что фраза-пароль передается открытым текстом с
     помощью стандартных пакетов с данными.  Данные будут в UTF-8.

‘Запросить подтверждение’
     Для запроса подтверждения (да или нет) можно воспользоваться
     командой:
            C: CONFIRM
            S: OK
     Перед тем как подать эту команду, программа-клиент должна задать
     соответствующий текст с помощью команды SETDESC; можно также задать
     тексты кнопок с помощью SETPROMPT. В случае положительного ответа
     возвращается OK, в других случаях возвращается код ошибки
     ‘ASSUAN_Not_Confirmed’.

‘Вывести сообщение’
     Для вывода сообщения можно воспользоваться командой:
            C: MESSAGE
            S: OK
     Как вариант, можно добавить кнопку для подтверждения:
            C: CONFIRM --one-button
            S: OK
     Перед тем как подать эту команду, программа-клиент должна задать
     соответствующий текст с помощью команды SETDESC; можно также задать
     текст кнопки с помощью SETOK. В случае положительного ответа
     возвращается OK, в других случаях возвращается код ошибки
     ‘ASSUAN_Not_Confirmed’.

‘Задать устройство вывода’
     При пользовании X программу PINENTRY надо вызывать с
     соответствующей переменной среды ‘DISPLAY’ или параметром
     ‘--display’.

     При пользовании текстовым терминалом:
            C: OPTION ttyname=/dev/tty3
            S: OK
            C: OPTION ttytype=vt100
            S: OK
            C: OPTION lc-ctype=de_DE.UTF-8
            S: OK
     Программа-клиент должна пользоваться параметром ‘ttyname’, чтобы
     задать имя выходного файла TTY, параметром ‘ttytype’, чтобы задать
     переменную ‘TERM’, соответствующую этому tty, и ‘lc-ctype’, чтобы
     задать параметры локализации, которые определяют кодировку
     терминала.

‘Задать исходные строки’
     Чтобы обойтись без переводов в самой программе PINENTRY, вызывающая
     программа может задавать определенные переведенные строки, которые
     PINENTRY использует в качестве исходных.

            C: OPTION default-ok=_Правильно
            S: OK
            C: OPTION default-cancel=Отбой
            S: OK
            C: OPTION default-prompt=Введите PIN:
            S: OK
     В этих строках клавиши быстрого доступа отмечаются, как в
     SETPROMPT.

‘Запоминание фраз-паролей’

     В некоторых средах, таких как GNOME, пароли запоминаются в буфере.
     Если задан параметр ‘allow-external-password-cache’, а также
     идентификатор ключа (с помощью SETKEYINFO), PINENTRY пользуется
     только внешним буфером.  В этом случае, если фраза-пароль
     считывается из буфера, PINENTRY высылает сообщение о состоянии
     ‘PASSWORD_FROM_CACHE’ перед тем, как выдать фразу-пароль.  Это
     указывает программе GPG-Agent, что увеличивать счетчик попыток
     ввода фразы-пароля не нужно.

            C: OPTION allow-external-password-cache
            S: OK
            C: SETKEYINFO код ключа
            S: OK
            C: getpin
            S: S PASSWORD_FROM_CACHE
            S: D 1234
            C: OK

     Замечание: если не задан ‘allow-external-password-cache’, внешний
     буфер паролей использоваться не должен: это может привести к
     трудноуловимым ошибкам.  В частности, если этот параметр не задан,
     GPG-Agent не учитывает сообщение о состоянии ‘PASSWORD_FROM_CACHE’
     и увеличивает счетчик попыток при пользовании паролем из буфера.
     Если счетчик попыток равен 1, у пользователя не будет возможности
     исправить пароль в буфере.

     Замечание: настоятельно рекомендуется, чтобы программа ввода
     пароля, которая поддерживает эту возможность, предоставляла
     пользователю возможность ручного включения ее.  То есть сохранение
     фразы-пароля во внешнем диспетчере паролей должно производиться по
     явному требованию.

     Формат идентификатора ключа, который выдает SETKEYINFO, следует
     считать недокументированным, в будущем он может изменяться.  В
     настоящее время он принимает вид ‘X/HEXSTRING’, где ‘X’ равен ‘n’,
     ‘s’ или ‘u’.  В двух первых случаях ‘HEXSTRING’ соответствует коду
     ключа.  Код ключа отличается от идентификатора ключа OpenPGP, но
     соответствие можно установить, выполнив

            # gpg2 --with-keygrip --list-secret-keys

     и найдя код ключа в выведенном списке.  Эти же параметры командной
     строки можно применять и с gpgsm.

4 Подробности реализации
************************

Исходный текст программы ввода пароля можно разделить на три части.
Есть рабочий модуль, он находится в ‘pinentry/’, есть служебные функции,
например, в ‘secmem/’, и есть различные пользовательские оболочки.

   Вся низкоуровневая логика живет в рабочем модуле.  Это от
необходимости реализовывать, например, протокол Assuan в
пользовательских оболочках.  Когда рабочий модуль получает параметр, он
обновляет состояние в структуре ‘pinentry_t’.  Пользовательская оболочка
вызывается, когда программа-клиент запрашивает ‘GETPIN’, ‘CONFIRM’ или
‘MESSAGE’.  В этих случаях рабочий модуль задействует функцию
‘pinentry_cmd_handler’, в которую передается структура ‘pinentry_t’.

   Когда задействуется функция обратного вызова, пользовательская
оболочка должна создать окно, соответствующее состоянию структуры
‘pinentry_t’.  Например, заголовок окна (если он есть) хранится в поле
‘title’.  Если это поле содержит ‘NULL’, оболочка должна выбрать
подходящее значение.  (Исходное значение задается не всегда, потому что
для разных инструментариев и сред подходят разные значения.)

   Окно должно поддерживать определенное количество различных видов
взаимодействия с пользователем.  Ниже описано каждый из них.

‘Подтверждение фразы-пароля’

     При создании ключа фразу-пароль нужно ввести дважды.
     Программа-клиент (обычно это GPG-Agent) информирует PINENTRY об
     этом с помощью ‘SETREPEAT’.  В этом случае рабочий модуль
     записывает в поле ‘repeat_passphrase’ копию переданной строки.
     Величина в этом поле должна использоваться в качестве метки для
     поля повторного ввода.

     Проверять, сходятся ли пароли, должна пользовательская оболочка.
     Если они не сходятся, оболочка должна отобразить сообщение об
     ошибке и продолжить запросы к пользователю.

     Если пароли сходятся и пользователь нажал кнопку подтверждения, в
     поле ‘repeat_okay’ должно быть занесена величина ‘1’ (в результате
     рабочий модуль выдает сообщение о состоянии ‘S PIN_REPEATED’).

‘Окно сообщения’

     Иногда программе GPG-Agent нужно отобразить сообщение.  В этом
     случае переменная ‘pin’ равна ‘NULL’.

     На уровне Assuan этот режим выбирается с помощью команды ‘MESSAGE’
     или ‘CONFIRM’ вместо команды ‘GETPIN’.  Команда ‘MESSAGE’ не
     показывает никаких кнопок.  То же самое верно для ‘CONFIRM’, если
     задан параметр ‘--one-button’.  Если в команде ‘CONFIRM’ этого
     параметра нет, в соответствующем окне будут кнопки ‘OK’, ‘CANCEL’,
     и (не обязательно) ‘NOTOK’.  Пользовательская оболочка может
     определить, должна ли быть в окне одна кнопка, анализируя
     переменную ‘one_button’.

‘Ввод фразы-пароля’

     В противном случае GPG-Agent просто запрашивает фразу-пароль.  В
     этом случае нужно показывать кнопки ‘OK’ и ‘CANCEL’.

   Во всех трех вариантах вид окна примерно одинаков.  Вот элементы,
которые определяют вид окна:

‘title’
     Заголовок окна.

‘description’
     Цель вывода окна.  При запросе фразы-пароля описывает ключ.  При
     выводе окна сообщения поле содержит текст этого сообщения.

‘error’
     Если GPG-Agent определяет, что фраза-пароль неверна, он снова
     вызывает ‘GETPIN’ (настраиваемое число раз) для повторного запроса
     к пользователю.  В этом случае эта переменная содержит описание
     ошибки.  Этот текст обычно нужно выделить тем или иным образом.

‘prompt, default-prompt’
     Строка, связанная с полем ввода фразы-пароля.

     Между ‘prompt’ и ‘default-prompt’ есть небольшое различие.
     ‘default-prompt’ означает, что можно использовать стилизованный
     запрос (например, в виде пиктограммы).  ‘prompt’ означает, что
     запрос несовместим с такой стилизацией, таким образом, пиктограммы
     применяться не должны.

     Если установлены обе переменные, ‘prompt’ имеет приоритет.

‘repeat_passphrase’
     Строка, связанная с полем повторного ввода фразы-пароля.  Поле
     повторного ввода нужно показывать, только если она не равна ‘NULL’.

‘ok, default-ok’
     Строка, которую нужно написать на кнопке ‘OK’.

     Если в строке есть символы ‘_’, следующий символ нужно использовать
     в качестве клавиши быстрого доступа (двойной символ подчеркивания
     означает, что просто должен быть показан символ подчеркивания).
     Если пользовательская оболочка не поддерживает клавиши быстрого
     доступа, то символы подчеркивания следует удалять вручную.

     Между ‘ok’ и ‘default-ok’ есть небольшое различие.  ‘default-ok’
     означает, что нужно использовать стилизованную кнопку.  Например,
     на ней может быть знак галочки.  ‘ok’ означает, что назначение
     кнопки не соответствует такой пиктограмме, таким образом,
     пиктограмма применяться не должна.  Таким образом, если на кнопке
     ‘ok’ должен быть текст «Пароль не требуется», нужно пользоваться
     вариантом ‘ok’, потому что пиктограмма с галочкой не имеет смысла.

     Если эта переменная равна ‘NULL’, пользовательская оболочка должна
     выбрать подходящее исходное значение.

     Если установлены обе переменные, ‘ok’ имеет приоритет.

‘cancel, default-cancel’
     Как ‘ok’ и ‘default-ok’, но строки используются для кнопки
     ‘cancel’.

     Если установлен признак ‘one_button’, эта кнопка должна
     отсутствовать.

‘default-notok’
     Как ‘default-ok’, но для второй кнопки.

     Эта кнопка должна отображаться только в окне сообщения.  Если эти
     переменные равны ‘NULL’ или установлен признак ‘one_button’, эта
     кнопка должна отсутствовать.

‘quality_bar’
     Если задано, нужен индикатор качества пароля.  Значение этого поля
     представляет метку для индикатора.

     Замечание: для обновления индикатора при каждом изменении пароля
     вызывайте функцию ‘pinentry_inq_quality’, обновляя соответствующим
     образом показания индикатора.

‘quality_bar_tt’
     Всплывающая подсказка для индикатора качества.

‘default_pwmngr’
     Если установлены ‘may_cache_password’ и ‘keyinfo’ и пользователь
     выражает согласие, PINENTRY может запоминать пароли во внешнем
     диспетчере.  Замечание: получать согласие пользователя важно,
     потому что диспетчеры паролей нередко обеспечивают другой уровень
     безопасности.  Если вышеозначенное условие выполняется, а признак
     ‘tried_password_cache’ сброшен, то нужно показывать элемент
     управления-флажок с указанной строкой.  В исходном состоянии флажок
     должен быть сброшен.

‘default-cf-visi’
     Строка, которая выводится с вопросом о том, хотите ли вы
     подтвердить, что пользователь желает сделать пароль видимым или
     невидимым.

‘default-tt-visi’
     Всплывающая подсказка для действия, которое открыло бы вводимый
     пароль.

‘default-tt-hide’
     Всплывающая подсказка для действия, которое скрыло бы пароль,
     открытый действием ‘default-tt-visi’.

   После обработки запроса программа по мере необходимости должна
сохранить фразу-пароль в ‘pin’.  Эта переменная размещается в безопасной
памяти.  Для изменения размера буфера пользуйтесь функцией
‘pinentry_setbufferlen’.

   Возвращаемый код выхода зависит от того, находится ли окно в режиме
вывода сообщения или в режиме ввода фразы-пароля.

   В режиме вывода сообщения возвращается 1, когда пользователь нажимает
‘ok’; в противном случае возвращается 0.  В случае ошибки ‘specific_err’
или setting ‘locale_err’ устанавливается в ‘1’ (для ошибок, связанных с
локализацией).  Если нажата кнопка ‘cancel’, переменной ‘canceled’
присваивается ‘1’.  Если нажата кнопка ‘notok’, никаких других действий
не производится.

   В режиме ввода фразы-пароля возвращается ‘1’, если пользователь ввел
пароль и нажал ‘ok’.  В случае ошибки возвращается ‘-1’ и
устанавливаются ‘specific_err’ или setting ‘locale_err’, как Если нажата
кнопка ‘cancel’, возвращается ‘-1’.

   Если окно закрывается, обработчик должен установить переменную
‘close_button’, а в остальном действовать, как если бы была нажата
кнопка ‘cancel’.

GNU General Public License
**************************

                         Version 2, June 1991

     Copyright © 1989, 1991 Free Software Foundation, Inc.
     59 Temple Place – Suite 330, Boston, MA 02111-1307, USA

     Everyone is permitted to copy and distribute verbatim copies
     of this license document, but changing it is not allowed.

Preamble
========

The licenses for most software are designed to take away your freedom to
share and change it.  By contrast, the GNU General Public License is
intended to guarantee your freedom to share and change free software—to
make sure the software is free for all its users.  This General Public
License applies to most of the Free Software Foundation’s software and
to any other program whose authors commit to using it.  (Some other Free
Software Foundation software is covered by the GNU Library General
Public License instead.)  You can apply it to your programs, too.

   When we speak of free software, we are referring to freedom, not
price.  Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
this service if you wish), that you receive source code or can get it if
you want it, that you can change the software or use pieces of it in new
free programs; and that you know you can do these things.

   To protect your rights, we need to make restrictions that forbid
anyone to deny you these rights or to ask you to surrender the rights.
These restrictions translate to certain responsibilities for you if you
distribute copies of the software, or if you modify it.

   For example, if you distribute copies of such a program, whether
gratis or for a fee, you must give the recipients all the rights that
you have.  You must make sure that they, too, receive or can get the
source code.  And you must show them these terms so they know their
rights.

   We protect your rights with two steps: (1) copyright the software,
and (2) offer you this license which gives you legal permission to copy,
distribute and/or modify the software.

   Also, for each author’s protection and ours, we want to make certain
that everyone understands that there is no warranty for this free
software.  If the software is modified by someone else and passed on, we
want its recipients to know that what they have is not the original, so
that any problems introduced by others will not reflect on the original
authors’ reputations.

   Finally, any free program is threatened constantly by software
patents.  We wish to avoid the danger that redistributors of a free
program will individually obtain patent licenses, in effect making the
program proprietary.  To prevent this, we have made it clear that any
patent must be licensed for everyone’s free use or not licensed at all.

   The precise terms and conditions for copying, distribution and
modification follow.

    TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  1. This License applies to any program or other work which contains a
     notice placed by the copyright holder saying it may be distributed
     under the terms of this General Public License.  The “Program”,
     below, refers to any such program or work, and a “work based on the
     Program” means either the Program or any derivative work under
     copyright law: that is to say, a work containing the Program or a
     portion of it, either verbatim or with modifications and/or
     translated into another language.  (Hereinafter, translation is
     included without limitation in the term “modification”.)  Each
     licensee is addressed as “you”.

     Activities other than copying, distribution and modification are
     not covered by this License; they are outside its scope.  The act
     of running the Program is not restricted, and the output from the
     Program is covered only if its contents constitute a work based on
     the Program (independent of having been made by running the
     Program).  Whether that is true depends on what the Program does.

  2. You may copy and distribute verbatim copies of the Program’s source
     code as you receive it, in any medium, provided that you
     conspicuously and appropriately publish on each copy an appropriate
     copyright notice and disclaimer of warranty; keep intact all the
     notices that refer to this License and to the absence of any
     warranty; and give any other recipients of the Program a copy of
     this License along with the Program.

     You may charge a fee for the physical act of transferring a copy,
     and you may at your option offer warranty protection in exchange
     for a fee.

  3. You may modify your copy or copies of the Program or any portion of
     it, thus forming a work based on the Program, and copy and
     distribute such modifications or work under the terms of Section 1
     above, provided that you also meet all of these conditions:

       a. You must cause the modified files to carry prominent notices
          stating that you changed the files and the date of any change.

       b. You must cause any work that you distribute or publish, that
          in whole or in part contains or is derived from the Program or
          any part thereof, to be licensed as a whole at no charge to
          all third parties under the terms of this License.

       c. If the modified program normally reads commands interactively
          when run, you must cause it, when started running for such
          interactive use in the most ordinary way, to print or display
          an announcement including an appropriate copyright notice and
          a notice that there is no warranty (or else, saying that you
          provide a warranty) and that users may redistribute the
          program under these conditions, and telling the user how to
          view a copy of this License.  (Exception: if the Program
          itself is interactive but does not normally print such an
          announcement, your work based on the Program is not required
          to print an announcement.)

     These requirements apply to the modified work as a whole.  If
     identifiable sections of that work are not derived from the
     Program, and can be reasonably considered independent and separate
     works in themselves, then this License, and its terms, do not apply
     to those sections when you distribute them as separate works.  But
     when you distribute the same sections as part of a whole which is a
     work based on the Program, the distribution of the whole must be on
     the terms of this License, whose permissions for other licensees
     extend to the entire whole, and thus to each and every part
     regardless of who wrote it.

     Thus, it is not the intent of this section to claim rights or
     contest your rights to work written entirely by you; rather, the
     intent is to exercise the right to control the distribution of
     derivative or collective works based on the Program.

     In addition, mere aggregation of another work not based on the
     Program with the Program (or with a work based on the Program) on a
     volume of a storage or distribution medium does not bring the other
     work under the scope of this License.

  4. You may copy and distribute the Program (or a work based on it,
     under Section 2) in object code or executable form under the terms
     of Sections 1 and 2 above provided that you also do one of the
     following:

       a. Accompany it with the complete corresponding machine-readable
          source code, which must be distributed under the terms of
          Sections 1 and 2 above on a medium customarily used for
          software interchange; or,

       b. Accompany it with a written offer, valid for at least three
          years, to give any third party, for a charge no more than your
          cost of physically performing source distribution, a complete
          machine-readable copy of the corresponding source code, to be
          distributed under the terms of Sections 1 and 2 above on a
          medium customarily used for software interchange; or,

       c. Accompany it with the information you received as to the offer
          to distribute corresponding source code.  (This alternative is
          allowed only for noncommercial distribution and only if you
          received the program in object code or executable form with
          such an offer, in accord with Subsection b above.)

     The source code for a work means the preferred form of the work for
     making modifications to it.  For an executable work, complete
     source code means all the source code for all modules it contains,
     plus any associated interface definition files, plus the scripts
     used to control compilation and installation of the executable.
     However, as a special exception, the source code distributed need
     not include anything that is normally distributed (in either source
     or binary form) with the major components (compiler, kernel, and so
     on) of the operating system on which the executable runs, unless
     that component itself accompanies the executable.

     If distribution of executable or object code is made by offering
     access to copy from a designated place, then offering equivalent
     access to copy the source code from the same place counts as
     distribution of the source code, even though third parties are not
     compelled to copy the source along with the object code.

  5. You may not copy, modify, sublicense, or distribute the Program
     except as expressly provided under this License.  Any attempt
     otherwise to copy, modify, sublicense or distribute the Program is
     void, and will automatically terminate your rights under this
     License.  However, parties who have received copies, or rights,
     from you under this License will not have their licenses terminated
     so long as such parties remain in full compliance.

  6. You are not required to accept this License, since you have not
     signed it.  However, nothing else grants you permission to modify
     or distribute the Program or its derivative works.  These actions
     are prohibited by law if you do not accept this License.
     Therefore, by modifying or distributing the Program (or any work
     based on the Program), you indicate your acceptance of this License
     to do so, and all its terms and conditions for copying,
     distributing or modifying the Program or works based on it.

  7. Each time you redistribute the Program (or any work based on the
     Program), the recipient automatically receives a license from the
     original licensor to copy, distribute or modify the Program subject
     to these terms and conditions.  You may not impose any further
     restrictions on the recipients’ exercise of the rights granted
     herein.  You are not responsible for enforcing compliance by third
     parties to this License.

  8. If, as a consequence of a court judgment or allegation of patent
     infringement or for any other reason (not limited to patent
     issues), conditions are imposed on you (whether by court order,
     agreement or otherwise) that contradict the conditions of this
     License, they do not excuse you from the conditions of this
     License.  If you cannot distribute so as to satisfy simultaneously
     your obligations under this License and any other pertinent
     obligations, then as a consequence you may not distribute the
     Program at all.  For example, if a patent license would not permit
     royalty-free redistribution of the Program by all those who receive
     copies directly or indirectly through you, then the only way you
     could satisfy both it and this License would be to refrain entirely
     from distribution of the Program.

     If any portion of this section is held invalid or unenforceable
     under any particular circumstance, the balance of the section is
     intended to apply and the section as a whole is intended to apply
     in other circumstances.

     It is not the purpose of this section to induce you to infringe any
     patents or other property right claims or to contest validity of
     any such claims; this section has the sole purpose of protecting
     the integrity of the free software distribution system, which is
     implemented by public license practices.  Many people have made
     generous contributions to the wide range of software distributed
     through that system in reliance on consistent application of that
     system; it is up to the author/donor to decide if he or she is
     willing to distribute software through any other system and a
     licensee cannot impose that choice.

     This section is intended to make thoroughly clear what is believed
     to be a consequence of the rest of this License.

  9. If the distribution and/or use of the Program is restricted in
     certain countries either by patents or by copyrighted interfaces,
     the original copyright holder who places the Program under this
     License may add an explicit geographical distribution limitation
     excluding those countries, so that distribution is permitted only
     in or among countries not thus excluded.  In such case, this
     License incorporates the limitation as if written in the body of
     this License.

  10. The Free Software Foundation may publish revised and/or new
     versions of the General Public License from time to time.  Such new
     versions will be similar in spirit to the present version, but may
     differ in detail to address new problems or concerns.

     Each version is given a distinguishing version number.  If the
     Program specifies a version number of this License which applies to
     it and “any later version”, you have the option of following the
     terms and conditions either of that version or of any later version
     published by the Free Software Foundation.  If the Program does not
     specify a version number of this License, you may choose any
     version ever published by the Free Software Foundation.

  11. If you wish to incorporate parts of the Program into other free
     programs whose distribution conditions are different, write to the
     author to ask for permission.  For software which is copyrighted by
     the Free Software Foundation, write to the Free Software
     Foundation; we sometimes make exceptions for this.  Our decision
     will be guided by the two goals of preserving the free status of
     all derivatives of our free software and of promoting the sharing
     and reuse of software generally.

                              NO WARRANTY

  12. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO
     WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE
     LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS
     AND/OR OTHER PARTIES PROVIDE THE PROGRAM “AS IS” WITHOUT WARRANTY
     OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT
     LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
     FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND
     PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE
     DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR
     OR CORRECTION.

  13. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
     WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY
     MODIFY AND/OR REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE
     LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL,
     INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR
     INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
     DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU
     OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY
     OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN
     ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

                      END OF TERMS AND CONDITIONS

How to Apply These Terms to Your New Programs
=============================================

If you develop a new program, and you want it to be of the greatest
possible use to the public, the best way to achieve this is to make it
free software which everyone can redistribute and change under these
terms.

   To do so, attach the following notices to the program.  It is safest
to attach them to the start of each source file to most effectively
convey the exclusion of warranty; and each file should have at least the
“copyright” line and a pointer to where the full notice is found.

     ONE LINE TO GIVE THE PROGRAM'S NAME AND AN IDEA OF WHAT IT DOES.
     Copyright (C) 19YY  NAME OF AUTHOR

     This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License along
     with this program; if not, write to the Free Software Foundation, Inc.,
     59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

   Also add information on how to contact you by electronic and paper
mail.

   If the program is interactive, make it output a short notice like
this when it starts in an interactive mode:

     Gnomovision version 69, Copyright (C) 19YY NAME OF AUTHOR
     Gnomovision comes with ABSOLUTELY NO WARRANTY; for details
     type `show w'.  This is free software, and you are welcome
     to redistribute it under certain conditions; type `show c'
     for details.

   The hypothetical commands ‘show w’ and ‘show c’ should show the
appropriate parts of the General Public License.  Of course, the
commands you use may be called something other than ‘show w’ and ‘show
c’; they could even be mouse-clicks or menu items—whatever suits your
program.

   You should also get your employer (if you work as a programmer) or
your school, if any, to sign a “copyright disclaimer” for the program,
if necessary.  Here is a sample; alter the names:

     Yoyodyne, Inc., hereby disclaims all copyright
     interest in the program `Gnomovision'
     (which makes passes at compilers) written
     by James Hacker.

     SIGNATURE OF TY COON, 1 April 1989
     Ty Coon, President of Vice

   This General Public License does not permit incorporating your
program into proprietary programs.  If your program is a subroutine
library, you may consider it more useful to permit linking proprietary
applications with the library.  If this is what you want to do, use the
GNU Library General Public License instead of this License.